/* lib/bgcolorpicker.p
 *
 * select a background color
 *
 */

define variable c as integer no-undo.

define variable i as integer no-undo.
define variable j as integer no-undo.
define variable k as integer no-undo.
define variable n as integer no-undo.

define variable bgColorList as character no-undo.
define variable dummy       as character no-undo extent   16 format "x(30)".		/* a fixed window for the frame					*/
define variable sample      as character no-undo extent /**/ format "x(30)".		/* an indeterminate array so that the list is easy to add to	*/

bgColorList = "blackbg,darkgray,lightgray,whitebg,cornsilk,lightblue,steelblue,honeydew,mintgreen,greenash,orangebg,mistyrose,pink".

n = num-entries( bgColorList ).

extent( sample ) = n.

do i = 1 to n:
  sample[i] = "  " + entry( i, bgColorList ).
end.

if current-window:width-chars < 160 then
  c = 20.
 else
  c = 60.

form
  dummy
 with
  frame showSample
  title " Choose Background Color "
  no-labels
  1 column
  overlay
  column c
  row (( screen-lines / 2 ) - ( n + 2 ))
.

procedure hiliteChoice:

  define input parameter bgChoice as integer no-undo.

  define variable i as integer no-undo.

  do i = 1 to n:
    if i = bgChoice then
      sample[i] = caps( sample[i] ).
     else
      sample[i] = lc( sample[i] ).
  end.

  return.

end.


procedure showColors:

  do i = 1 to extent( dummy ):
    color display value( trim( sample[i + k] )) dummy[i] with frame showSample.
    display sample[i + k] @ dummy[i] with frame showSample.
  end.

  return.

end.


/* main block
 */

do on stop undo, leave
   on error undo, leave
   on endkey undo, leave:

  j = lookup( terminal, bgColorList ).
  if j < 1 then
    j = 1.

  do while true:

    run hiliteChoice( j ).

    run showColors.

    readkey.

    if keyfunction( lastkey ) = "cursor-up" then
      j = j - 1.
     else if keyfunction( lastkey ) = "cursor-down" then
      j = j + 1.
     else
      leave.

    if j < 1 then j = n.
    if j > n then j = 1.

    if j <= extent( dummy ) then
      k = 0.
     else
      k = j - extent( dummy ).

  end.

  hide frame showSample no-pause.

  if keyfunction( lastkey ) = "go" or keyfunction( lastkey ) = "return"  or keyfunction( lastkey ) = "enter" or keyfunction( lastkey ) = " "  then
    terminal = lc( trim( sample[j] )) no-error.

end.

return.

