/* cryptfile.p
 *
 * encrypt/decrypt a file using gcr_encrypt() - the algorithm is symmetric, run it once to encrypt, again to decrypt
 *
 * pro -p cryptfile.p -param fileName
 *
 */

{lib/protop.i}
{lib/protoplib.i}

define variable keyText  as character no-undo /**/ initial "NiceLongPassword" /**/ .

define variable fileName as character no-undo.
define variable m        as memptr    no-undo.

define variable st as integer no-undo.
define variable et as integer no-undo.
define variable sz as integer no-undo.

run lib/protoplib.p persistent.
run build_xor.

if session:parameter <> "" then
  fileName = session:parameter.
 else
  update fileName.

file-info:file-name = fileName.
if file-info:full-pathname = ? then
  do:
    message "no such file:" fileName.
    quit.
  end.

if keyText = ? or length( keyText ) < 8 then
  update keyText format "x(60)".

keyText = fileName + keyText.

sz = file-info:file-size.
set-size( m ) = sz.
set-byte-order( m ) = 3.

input from value( file-info:full-pathname ) binary no-convert.
import m.
input close.

st = etime.
run gcr_encrypt( keytext, m ).
et = etime.

output to value ( file-info:full-pathname ) binary no-convert.
export m.
output close.

set-size( m ) = 0.

et = et - st.

message sz "/" et "ms =" (( sz / 1024 ) / ( et / 1000.0 )) "KB/sec".

quit.
