/* pthelp.p
 *
 */


define new global shared variable pt_helplink as character no-undo.
define new global shared variable pt_commlink as character no-undo.

session:add-super-procedure( this-procedure ).

if session:batch = no and current-window:width-chars < 160 then
  do:
    subscribe to "protop_help"    anywhere run-procedure "protop_help80".
    subscribe to "protop_faqhelp" anywhere run-procedure "protop_faqhelp80".
  end.
 else
  do:
    subscribe to "protop_help"    anywhere run-procedure "protop_help".
    subscribe to "protop_faqhelp" anywhere run-procedure "protop_faqhelp".
  end.

subscribe to "protop_dothelp" anywhere run-procedure "protop_dothelp".
subscribe to "fileViewerHelp" anywhere run-procedure "fileViewerHelp".
subscribe to "protop_noLOBs"  anywhere run-procedure "protop_noLOBs".

return.


/* https://gist.github.com/egmontkob/eb114294efbcd5adb1944c9f3cb5feda
 */

function putLink returns logical ( input link as character, input r as integer, input c as integer, input x as character ):
  define variable url as character no-undo.
  url = link + chr(27) + chr(92) + link.
  put screen color value( "LINK" + x ) row r column c url.	/* each link needs a unique id, the id is embedded in the color code	*/
  return true.
end.


procedure protop_help:

  define variable links as character no-undo format "x(102)".

  if pt_helplink = ? or pt_helplink = "" then
    pt_helplink = "https://wss.com/protop/help/".

  if pt_commlink = ? or pt_commlink = "" then
    pt_commlink = "https://community.wss.com/".

  links = substitute( "Online Help: &1 &3 Forum: &2", pt_helplink, pt_commlink, fill( " ", 81 - length( pt_helplink + pt_commlink ))).
  links = substitute( "Forum: &1 &3 Online Help: &2", pt_commlink, pt_helplink, fill( " ", 81 - length( pt_helplink + pt_commlink ))).

  display
    skip(1)															/* 03 */
    "                                       Command Keys are Case-Sensitive                                      " skip		/* 04 */
    skip(1)															/* 05 */
    "  d = Performance Dashboard              c = Configuration Viewer         o = OS Info (if avail)            " skip		/* 06 */
    skip(1)															/* 07 */
    "  t = Table Activity                     w = Latches and Resources        Q = SQL activity                  " skip		/* 08 */
    "  i = Index Activity                     k = Checkpoints                  D = Disk Free Space               " skip		/* 09 */
    "  l = LOB Activity                       b = Blocked Sessions             / = Sequences                     " skip		/* 10 */
    "  u = User IO Activity                   r = OE Replication Agents        N = Network Traffic               " skip		/* 11 */
    "  x = Active Transactions                f = File IO                      W = Who is Connected?             " skip		/* 12 */
    "  L = Login Brokers                      s = Server Activity              m = Multi-Tenant Info             " skip		/* 13 */
    '  a = Storage Areas                      A = "Classic" App Servers        e = Application Specific          ' skip		/* 14 */
    " ^b = Buffer Pools                       B = BigB Guesstimator           ^a = After-Imaging Info            " skip		/* 15 */
    skip(1)															/* 16 */
    "  U = User Information Viewer            # = Set Usr#                     P = Set Process Id                " skip		/* 17 */
    '  H = Health Check                       * = Client Statement Cache       _ = Clear Client Statement Cache  ' skip		/* 18 */
    ' ^l = Progress "showcfg" info            3 = User IO client-type filter                                     ' skip		/* 19 */
    skip(1)															/* 20 */
    "  0 = Color Picker                       6 = Set Table Name               8 = Monitor Users of a Table      " skip		/* 21 */
    "  ! = Generate DBAnalys Output           7 = Set Index Name               9 = Monitor Users of an Index     " skip		/* 22 */
    "  R = DB Parameters Report               S = Client/Server Parameters     T = Show Table and Index Ranges   " skip		/* 23 */
    skip(1)															/* 24 */
    "  2 = Pro2 Queues                        j = PASOE Health Scanner         C = CDC Processing Queue          " skip		/* 25 */
    skip(1)															/* 26 */
    " ^p = programmer mode                   ^u = SQL update stats script     ^t = show session temp-tables      " skip		/* 27 */
    " ^d = dump & load scripts               ^r = dbanalys review & reports    Y = show session user*stat        " skip		/* 28 */
    " ^f = FAQ about oddball stuff            v = view reports                 y = run profiler on this session  " skip		/* 29 */
    skip(1)															/* 30 */
    "  ; = Set Refresh Interval               ^ = Modify Sort Columns          & = Show ProTop Properties        " skip		/* 31 */
    skip(1)															/* 32 */
    "      % = Switch between Raw and Rate Sampling         $ = Switch between Auto and On-Demand Sampling       " skip		/* 33 */
    "      p = Pause to allow manual Screen Capture              @ = Send Screen Content as an e-mail            " skip		/* 34 */
    "             ( = Set Top X Row Limit                           ) = Modify _Lock Scan Limit                  " skip		/* 35 */	/* I'm not sure either of these should be advertised...	*/
    skip(1)															/* 36 */
    "                                  <space> = Refresh Sample (or un-pause)                                    " skip		/* 37 */
    "                                            Z = Repaint Screen                                              " skip		/* 38 */
    "                                                h, ? = Help                                                 " skip		/* 39 */
    "                                                  q = Quit                                                  " skip		/* 40 */
    skip(1)															/* 41 */
    " " links skip		  	/* URLs to ProTop Community & Documentation */						/* 42 */
    skip(1)															/* 43 */
   with
    frame show-help
    title " ProTop Help - Command Keys "
    row ( if screen-lines >= 48 then 4 else 2 )
    column 25
    width 110
    overlay
    no-labels
  .

  if os-getenv( "TERMHOTLINK" ) = "yes" then
    do:
      putLink( pt_commlink, ( if screen-lines >= 48 then 43 else 41 ), 35, "1" ).
      putLink( pt_helplink, ( if screen-lines >= 48 then 43 else 41 ), 131 - length( pt_helplink ), "2" ).
    end.

  do on error undo, leave
     on endkey undo, leave:

    pause.

  end.

  hide frame show-help.

end.

procedure protop_help80:

  define variable links as character no-undo format "x(60)".

  if pt_helplink = ? or pt_helplink = "" then
    pt_helplink = "https://wss.com/protop/help/".

  if pt_commlink = ? or pt_commlink = "" then
    pt_commlink = "https://community.wss.com/".

/* +++
 * links = substitute( "Online Help: &1 &3 Forum: &2", pt_helplink, pt_commlink, fill( " ", 31 - length( pt_helplink + pt_commlink ))).
 * links = substitute( "Forum: &1 &3 Online Help: &2", pt_commlink, pt_helplink, fill( " ", 31 - length( pt_helplink + pt_commlink ))).
 */

  links = substitute( "  Online Help: &1", pt_helplink ).

   /*         1         2         3         4         5         6         7         8*/
   /*12345678901234567890123456789012345678901234567890123456789012345678901234567890*/

											/* 01 */	/* screen header line 1	*/
											/* 02 */	/* screen header line 2	*/
											/* 03 */	/* screen header line 3	*/
  display			/** title **/						/* 04 */
    skip(1)										/* 05 */
    "                   Command Keys are Case-Sensitive                 " skip		/* 06 */
    skip(1)										/* 07 */
    "  d = Performance Dashboard         c = Configuration Viewer       " skip		/* 08 */
    skip(1)										/* 09 */
    "  t = Table Activity                w = Latches and Resources      " skip		/* 10 */
    "  i = Index Activity                k = Checkpoints                " skip		/* 11 */
    "  l = LOB Activity                  b = Blocked Sessions           " skip		/* 12 */
    "  u = User IO Activity              N = Network Traffic            " skip		/* 13 */
    "  x = Active Transactions           D = Disk Free Space            " skip		/* 14 */
    "  2 = Pro2 Queues                   C = CDC Processing Queue       " skip		/* 15 */
    "  * = Client Statement Cache       ^a = After-Imaging Info         " skip		/* 16 */
    "  R = DB Parameters Report          S = Client/Server Param Report " skip		/* 17 */
    "  ! = Generate DBAnalys Output     ^r = dbanalys review & reports  " skip		/* 18 */
    " ^p = programmer mode               v = view reports               " skip		/* 19 */
    skip(1)										/* 20 */
    links skip			  	/* URLs to ProTop Community & Documentation */	/* 21 */
    skip(1)			/** bottom **/						/* 22 */
   with											/* 23 */	/* messages line 1	*/
    frame show-help80									/* 24 */	/* messages line 1	*/
    title " ProTop Help - Command Keys "						/* 25 */	/* status line		*/
    row 2
    column 6
    width 70
    overlay
    no-labels
  .

/*
 *  if os-getenv( "TERMHOTLINK" ) = "yes" then
 *    do:
 *      putLink( pt_commlink, ( if screen-lines >= 48 then 43 else 41 ), 35, "1" ).
 *      putLink( pt_helplink, ( if screen-lines >= 48 then 43 else 41 ), 131 - length( pt_helplink ), "2" ).
 *    end.
 */

  do on error undo, leave
     on endkey undo, leave:

    pause.

  end.

  hide frame show-help80.

end.


procedure protop_FAQhelp:

  display
    skip(1)
    '                                     Oddball Information                                      ' skip
    skip(1)
    " Screen Header, Top Left                                                                      " skip
    " -----------------------                                                                      " skip
    "   date                                                                                       " skip
    "   programmerMode                                                                             " skip
    "   lastCommandKey, commandKeyHistory                                                          " skip
    skip(2)
    ' UIO/Active TRX/Blocked Session "Flags"                                                       ' skip
    " --------------------------------------                                                       " skip
    "   S = self service    4 = 4gl          B = batch             N- = notification pending       " skip
    "   R = remote client   W = webspeed                           -N = notification in process    " skip
    "   L = login broker    A = app server   * = TRX active        NN = pending and in process     " skip
    "   @ = server          P = PASOE        d = disconnecting                                     " skip
    "   H = helper          Q = SQL          r = undo or error                                     " skip
    "   O = other           X = Unknown      i = STOP or ^C                                        " skip
    skip(2)
    " Lock Type                                    Lock Flags                                      " skip
    " --------------------------------------       --------------------------------------------    " skip
    "   X   = exclusive                            C = create                  K = keep            " skip
    "   S   = share                                D = downgrade               L = limbo           " skip
    "   IX  = intent exclusive                     E = expired                 P = purged          " skip
    "   IS  = intent share                         H = on hold                 Q = queued          " skip
    "   SIX = share on table, with intent          J = JTA                     U = upgrade         " skip
    "         to set exclusive on records                                                          " skip
    skip(2)
    " Pro2 Queue Depth Calculation Type Indicators                                                 " skip
    " ------------------------------------------------                                             " skip
    "   x = Exact, 2 = Pro2 Internal, p = Proportional                                             " skip
    skip(2)
    ' Obscure Commands                                                                             ' skip
    " ----------------                                                                             " skip
    "   DELETE-WORD (ESC-D) = set the ProTop internal debug level                                  " skip
    skip(1)
   with
    frame show-faqhelp
    title ' ProTop "FAQ" Help '
    row ( if screen-lines >= 42 then 4 else 1 )
    column 32
    width 96
    overlay
  .

  /* https://knowledgebase.progress.com/articles/Knowledge/21639 - info re: _lock-flags	*/
  /* https://knowledgebase.progress.com/articles/Article/P6854 - info: re table locks	*/

  do on error undo, leave
     on endkey undo, leave:

    pause.

  end.

  hide frame show-faqhelp.

end.


procedure protop_FAQhelp80:

  display
    skip(1)
    '                                     Oddball Information                                      ' skip
    skip(1)
    ' UIO/Active TRX/Blocked Session "Flags"                                                       ' skip
    " --------------------------------------                                                       " skip
    "   S = self service    4 = 4gl          B = batch             N- = notification pending       " skip
    "   R = remote client   W = webspeed                           -N = notification in process    " skip
    "   L = login broker    A = app server   * = TRX active        NN = pending and in process     " skip
    "   @ = server          P = PASOE        d = disconnecting                                     " skip
    "   H = helper          Q = SQL          r = undo or error                                     " skip
    "   O = other           X = Unknown      i = STOP or ^C                                        " skip
    skip(1)
    " Lock Type                                    Lock Flags                                      " skip
    " --------------------------------------       --------------------------------------------    " skip
    "   X   = exclusive                            C = create                  K = keep            " skip
    "   S   = share                                D = downgrade               L = limbo           " skip
    "   IX  = intent exclusive                     E = expired                 P = purged          " skip
    "   IS  = intent share                         H = on hold                 Q = queued          " skip
    "   SIX = share on table, with intent          J = JTA                     U = upgrade         " skip
    "         to set exclusive on records                                                          " skip
    skip(2)
    " Pro2 Queue Depth Calculation Type Indicators                                                 " skip
    " ------------------------------------------------                                             " skip
    "   x = Exact, 2 = Pro2 Internal, p = Proportional                                             " skip
    skip(2)
    ' Obscure Commands                                                                             ' skip
    " ----------------                                                                             " skip
    "   DELETE-WORD (ESC-D) = set the ProTop internal debug level                                  " skip
    skip(1)
   with
    frame show-faqhelp80
    title ' ProTop "FAQ" Help '
    row ( if screen-lines >= 42 then 4 else 1 )
    column 1
    width 96
    overlay
  .

  /* https://knowledgebase.progress.com/articles/Knowledge/21639 - info re: _lock-flags	*/
  /* https://knowledgebase.progress.com/articles/Article/P6854 - info: re table locks	*/

  do on error undo, leave
     on endkey undo, leave:

    pause.

  end.

  hide frame show-faqhelp80.

end.


procedure protop_dothelp:

  display
    skip(1)
    '                    Zecret Commands Pre-fixed with a "."                  ' skip
    skip(1)
    ' . =  Make "dot" sticky (or unsticky)                                     ' skip
    skip(1)
    '              See s2k_demo/README for a slightly more detailed            ' skip
    '              description of the demo programs.                           ' skip
    skip(1)
    " 0 =  Shutdown demo programs (remove .flg files)                          " skip
    " 1 =  Blended demo: churn, lockalot, updorder, badtrx, blocker and victim " skip
    " 2 =         churn: generate a *lot* of activity on a very small table    " skip
    " 3 =      lockalot: lock a random number of records                       " skip
    " 4 =      updorder: update an order (victim of badtrx)                    " skip
    " 5 =        badtrx: start a poorly scoped transaction and cause bi growth " skip
    " 6 =       blocker: lock a record that victim needs                       " skip
    " 7 =        victim: be the victim of a lock conflict (caused by blocker)  " skip
    " 8 =      badorder: badly count bad orders (not run by blended demo)      " skip
    skip(1)
    " u =  Enable user defined metrics (lib/sports2000.p) on dashboard screen  " skip
    skip(1)
    '        THE DATABASE MUST BE NAMED "sports2000", "s2k", or "bigsports".   ' skip
    '            OTHER DATABASE NAMES WILL NOT WORK WITH THIS DEMO CODE.       ' skip
    skip(1)
    " & = Show Zecret Properties                                               " skip
    skip(1)
    "                               h, ? = Help                                " skip
    skip(1)
   with
    frame show-dothelp
    title ' ProTop "Dot" Help - Command Keys '
    row ( if screen-lines >= 42 then 4 else 1 )
    column ( if session:batch = no and current-window:width-chars < 160 then 1 else 40 )
    width 80
    overlay
  .

  do on error undo, leave
     on endkey undo, leave:

    pause.

  end.

  hide frame show-dothelp.

end.


procedure fileViewerHelp:

  display
    skip(1)
    " Ordinary cursor movement keys should work as usual. These  " skip
    " keys are in addition to those ordinary commands.           " skip
    skip(1)
    "      x, q         Exit the fileviewer.                     " skip
    "      +, d         Page down                                " skip
    "      -, u         Page up                                  " skip
    "      >            Jump to End of File                      " skip
    "      <            Jump to Beginning of File                " skip
    "      /, s, f      Search for text                          " skip
    "      n            Find Next                                " skip
    "      p            Find Previous                            " skip
    "      h, j, k, l   vi cursor control                        " skip
    "      ^            Beginning of Line                        " skip
    "      $            End of Line                              " skip
    skip(1)
    "                        ? = Help                            " skip
    skip(1)
   with
    frame show-fileViewerHelp
    title ' File Viewer Help - Special Command Keys '
    row ( if screen-lines >= 42 then 4 else 1 )
    column ( if session:batch = no and current-window:width-chars < 160 then 8 else 48 )
    width 62
    overlay
  .

  do on error undo, leave
     on endkey undo, leave:

    pause.

  end.

  hide frame show-fileViewerHelp.

end.


procedure protop_noLOBs:

  display
    skip(1)
    "   LOB Activity Statisics require OpenEdge 12 or better.   " skip
    skip(1)
   with
    frame show-noLOBs
    title substitute( " No LOB Activity support in &1 ", proversion )
    row 4
    column ( if session:batch = no and current-window:width-chars < 160 then 8 else 48 )
    width 62
    overlay
  .

  do on error undo, leave
     on endkey undo, leave:

    pause.

  end.

  hide frame show-noLOBs.

end.

