#!/bin/sh
#
# bin/dbanalys.sh
#
# usage:
#
#	bin/dbanalys.sh /db/dbname friendlyName
#
# crontab:
#
#	0 1 * * 6 dbanalys.sh /db/sports sports > /tmp/dbanalys.log 2>&1 &
#

. #ENVPT3#/bin/protopenv

TMPDIR=${TMPDIR-/tmp}
LOGDIR=${LOGDIR-/tmp}

errmsg()
{
	echo ""
	echo "${1}"
	echo ""
}

if [ ! -d ${TMPDIR} ]
then
        mkdir ${TMPDIR}
fi

if [ ! -d ${LOGDIR} ]
then
        mkdir ${LOGDIR}
fi

DBPATH=${1}
if [ -z "${DBPATH}" ]
then
	errmsg "Please specify a database path."
	exit
fi

# FRNAME is a "friendly name" in etc/dblist.cfg
#

FRNAME=${2}

if [ -z "${FRNAME}" ]
then
	errmsg "Please specify a friendly name in etc/dblist.cfg."
	exit
fi

# get a fresh dbanalys
#

if [ ! -f ${DBPATH}.db ]
then
	errmsg "${DBPATH}.db does not exist."
else
	${DLC}/bin/proutil ${DBPATH} -C dbanalys -Bp 10 > ${PROTOP}/dbanalys/${FRNAME}.dba 2> ${TMPDIR}/dbanalys.${FRNAME}.err &
fi

