#!/bin/sh
#
# ${PROTOP}/bin/trxmon.sh friendlyName
#

. #ENVPT3#/bin/protopenv

TMPDIR=${TMPDIR-/tmp}
LOGDIR=${LOGDIR-/tmp}

MNAME="trxmon"

cd ${PROTOP}

if [ ! -d ${TMPDIR} ]
then
        mkdir ${TMPDIR}
fi

if [ ! -d ${LOGDIR} ]
then
        mkdir ${LOGDIR}
fi

if [ -f ${TMPDIR}/MAINTENANCE ]
then
        rm -f ${TMPDIR}/*.flg
        exit
fi

errmsg()
{
	echo ""
	echo "${1}"
	echo ""
}

# save ${1} and shift the command args so that we can easily pass along $2 etc
#
# P1 is a "friendly name" in etc/dblist.cfg
#

P1=${1}

if [ -z "${P1}" ]
then
	errmsg "Please specify a friendly name in etc/dblist.cfg."
	exit
fi

shift
XDB=

if [ -f ${PROTOP}/etc/dblist.cfg ]	# search using "pipe" as the delimiter
then
	XDB=`grep "^${P1}|" ${PROTOP}/etc/dblist.cfg | awk -F "|" '{print $2}' 2>/dev/null`
else
	echo "No ${PROTOP}/etc/dblist.cfg!  You must use bin/dbmaint.sh to create friendly names first!"
	exit
fi

# if XDB has a value then we found a friendly name and the path is in XDB
#

if [ ! -z "${XDB}" ]					# friendly name!
then
	PARAM='-param '"${P1}"				# pass the friendly name into protop.p
else
	errmsg "Please specify a friendly name in etc/dblist.cfg."
	exit
fi

if [ -f ${XDB}.db ]
then

	# launch if we are not already running
	#

	X=`ps -ef | grep "util/${MNAME}.p ${XDB} " | grep [_]progres`
	if [ -z "${X}" ]
	then

		${DLC}/bin/_progres -b -p util/${MNAME}.p ${XDB} ${PFLIST} ${PARAM} -T ${TMPDIR} ${ERRSTACK} -clientlog ${TMPDIR}/${MNAME}.${P1}.debug $* >> ${TMPDIR}/${MNAME}.${P1}.err 2>&1 &

	fi

else
	errmsg "${XDB}.db does not exist."
fi
