/* dbparamrpt.p
 *
 */

define new global shared variable pt_rptdir      as character no-undo initial ".".
define new global shared variable pt_shortname   as character no-undo.

define variable nastyGram as character no-undo format "x(90)".

define variable qh as handle no-undo.
define variable bh as handle no-undo.

define variable rptOut as character no-undo.

define variable sql_param_name       as character no-undo format "x(30)"  label "SQL Parameter Name".
define variable sql_param_value      as character no-undo format "x(16)"  label "Value".
define variable sql_param_is-default as character no-undo format "yes/no" label "Default?".

define variable sum_mpb as integer no-undo.
define variable sum_cnx as integer no-undo.

define variable i as integer no-undo format ">>9".
define variable j as integer no-undo format ">>9".

define variable svt as integer no-undo.
define variable mpb as integer no-undo.
define variable ma  as integer no-undo.

define variable dashN  as integer no-undo.
define variable dashMn as integer no-undo.

define variable areaType     as integer   no-undo.
define variable areaTypeCode as character no-undo initial "b,a,d".

define variable blksAlloc    as decimal   no-undo.
define variable blksVar      as decimal   no-undo.
define variable blksFree     as decimal   no-undo.
define variable extBlks      as decimal   no-undo.
define variable blkSzKb      as decimal   no-undo.

define variable hasSrvBrkPID as logical no-undo.

find _file no-lock where _file-name = "_servers" no-error.

if available _file then
  do:

    find dictdb._field no-lock where _field._file-recid = recid( _file ) and _field-name = "_Server-Broker-Pid" no-error.
    hasSrvBrkPID = available( _field ).

  end.

define buffer broker for _servers.
define buffer srvrs  for _servers.


rptOut = substitute( "&1/&2.dbparam.rpt", pt_rptdir, max( pt_shortname, ldbname(1))).

find _file no-lock where _file._file-name = "_dbParams" no-error.

if not available _file or decimal( substring( proversion, 1, index( proversion, "." ) + 1 )) < 11.5 then
  do:

    nastyGram = "  This functionality requires OpenEdge 11.5 or better with the _dbParams VST activated.  ".

    form
      skip(1)
      nastyGram skip
      skip(1)
     with
      frame oe115
      centered
      row 20
      overlay
      no-labels
      width 96
    .
    color display value( if opsys = "unix" then "RED" else "RED/WHITE" ) nastyGram with frame oe115.
    display
      nastyGram
     with
      frame oe115
    .
    pause.
    hide frame oe115 no-pause.

  end.
 else
  do:

    create buffer bh for table "_dbParams".
    create query qh.
    qh:set-buffers( bh ).
    qh:query-prepare( "for each _dbParams no-lock" ).
    qh:query-open.

    output to value( rptOut ).

    put unformatted pdbname(1) fill( " ", ( 129 - length( pdbname(1)))) now skip.
    put skip(1).

    output close.

    os-command silent value( substitute( "proutil &1 -C describe >> &2", pdbname(1), rptOut )).

    output to value( rptOut ) append.

    put skip(1).
    put unformatted "Parameter Name         Def?  Mod?  Value                                         Description" skip.
    put unformatted "---------------------- ----- ----- --------------------------------------------- -----------------------------------------------------------------------------" skip.

    qh:get-next().

    do while qh:query-off-end = false:

      put unformatted
        bh:buffer-field( "_dbParams-Name" ):buffer-value()          format "x(22)"  space
        logical( bh:buffer-field( "_dbParams-Is-Default" ):buffer-value())    format "Yes/No" space(3)
        logical( bh:buffer-field( "_dbParams-Is-Modifiable" ):buffer-value()) format "Yes/No" space(3)
        bh:buffer-field( "_dbParams-Value" ):buffer-value()         format "x(42)"
      .

      if length( bh:buffer-field( "_dbParams-Value" ):buffer-value() ) > 42 then
        put "..." space.
       else
        put space(4).

      put unformatted
        trim( substring( bh:buffer-field( "_dbParams-Desc" ):buffer-value(), 1, index( bh:buffer-field( "_dbParams-Desc" ):buffer-value(), " (" )))
        skip
      .

      if bh:buffer-field( "_dbParams-Name" ):buffer-value() = "-n" and bh:buffer-field( "_dbParams-Desc" ):buffer-value() <> "Network Type" then
        dashN = integer( bh:buffer-field( "_dbParams-Value" ):buffer-value() ) no-error.

      if bh:buffer-field( "_dbParams-Name" ):buffer-value() = "-Mn" then
        dashMn = integer( bh:buffer-field( "_dbParams-Value" ):buffer-value() ) no-error.

      qh:get-next().

    end.
    put skip(1).


    /* remote server parameters
     */

    put skip(1).
    put unformatted "Remote Server Configuration" skip.
    put unformatted "===========================" skip.

    for each broker no-lock where broker._server-type = "login":

      find_serverType: do i = 1 to 64:
        if       buffer broker:handle:buffer-field( "_srvParam-name" ):buffer-value( i ) = "-ServerType" then svt = i.
         else if buffer broker:handle:buffer-field( "_srvParam-name" ):buffer-value( i ) = "-Mpb"        then mpb = i.
         else if buffer broker:handle:buffer-field( "_srvParam-name" ):buffer-value( i ) = "-Ma"         then ma  = i.
      end.

      i = 0.

      put unformatted skip(1).
      put unformatted fill( "=", 80 ) skip.
      put unformatted skip(1).

      if broker._server-portnum = 0 then
        put unformatted substitute( "Default &1 login broker on port &2 (unusable)", buffer broker:handle:buffer-field( "_srvParam-value" ):buffer-value( svt ), _server-portnum ) skip.
       else
        put unformatted substitute( "Remote &1 login broker on port &2", buffer broker:handle:buffer-field( "_srvParam-value" ):buffer-value( svt ), _server-portnum ) skip.

      j = svt.

      do i = svt to 1 by -1:

        j = j + 1.

        display

          /* i */
          buffer broker:handle:buffer-field( "_srvParam-name" ):buffer-value( i ) format "x(30)" label "Parameter Name"
          buffer broker:handle:buffer-field( "_srvParam-value" ):buffer-value( i )  label "Value"
          buffer broker:handle:buffer-field( "_srvParam-is-default" ):buffer-value( i ) label "Default?"

          space(9)

          /* j */
          buffer broker:handle:buffer-field( "_srvParam-name" ):buffer-value( j )       when buffer broker:handle:buffer-field( "_srvParam-name" ):buffer-value( j )       <> ? and buffer broker:handle:buffer-field( "_srvParam-value" ):buffer-value( svt ) <> "ABL" @ sql_param_name
          buffer broker:handle:buffer-field( "_srvParam-value" ):buffer-value( j )      when buffer broker:handle:buffer-field( "_srvParam-value" ):buffer-value( j )      <> ? and buffer broker:handle:buffer-field( "_srvParam-value" ):buffer-value( svt ) <> "ABL" @ sql_param_value
          logical( buffer broker:handle:buffer-field( "_srvParam-is-default" ):buffer-value( j )) when buffer broker:handle:buffer-field( "_srvParam-is-default" ):buffer-value( j ) <> ? and buffer broker:handle:buffer-field( "_srvParam-value" ):buffer-value( svt ) <> "ABL" @ sql_param_is-default

         with
          frame b
          width 132
          down
        .

        down 1 with frame b.

      end.

      sum_mpb = sum_mpb + integer( buffer broker:handle:buffer-field( "_srvParam-value" ):buffer-value( mpb )) + 1 no-error.
      sum_cnx = sum_cnx + ( integer( buffer broker:handle:buffer-field( "_srvParam-value" ):buffer-value( mpb )) + 1 ) * integer( buffer broker:handle:buffer-field( "_srvParam-value" ):buffer-value( ma )) no-error.

      /*** 
       *** details for each server

      for each _servers no-lock:

        if hasSrvBrkPID = no then next.

        if buffer _servers:handle:buffer-field( "_server-broker-pid" ):buffer-value <> buffer broker:handle:buffer-field( "_server-broker-pid" ):buffer-value then
          next.

        display
          _servers._server-id         label "Id"       format ">>>>>9"
          _servers._server-num        label "Server#"  format ">>>>>9"
          _servers._server-pid        label "PID"
          _servers._server-type       label "Type"
          _servers._server-portnum    label "Port"
          _servers._server-logins     label "Logins"   format "->>>>>>>>>>>>>>>>>>9"
         with
          frame c
          width 132
          down
        .

      end.

       ***/

    end.

    put unformatted skip(1).
    put unformatted fill( "=", 80 ) skip.
    put unformatted skip(1).

    put unformatted "To fully support these remote servers:" skip.
    put unformatted substitute( "     -n should be at least: &1 (actual = &2)", sum_cnx + 5, dashN  ) skip.
    put unformatted substitute( "    -Mn should be at least: &1 (actual = &2)", sum_mpb + 1, dashMn ) skip.
    put skip(1).


    /* db structure
     */

    for each dictdb._areaStatus no-lock:

      assign
        blksAlloc = 0
        blksVar   = 0
      .

      if _AreaStatus-areaNum < 6 and _AreaStatus-areaNum <> 3 then next.

      put unformatted "#" skip.

      find dictdb._Area no-lock where _Area._area-number = _areaStatus-areaNum.

      blkSzKB = _Area-blocksize / 1024.					/* _area-blocksize is in bytes		*/

      for each dictdb._areaExtent no-lock where _areaExtent._Area-Number = _areaStatus-areaNum.

        extBlks = ( _areaExtent._Extent-Size / blkSzKB ).
        if extBlks = ? then extBlks = 0.

        if _extent-type >= 4 and _extent-type <= 7 then
          blksVar = max( extBlks, ( _AreaStatus-totblocks - blksAlloc )).
         else
          blksAlloc = blksAlloc + extBlks.

        if _AreaStatus-areaName begins "Primary Recovery Area" then
          areaType = 1.
         else if _AreaStatus-areaName begins "After Image Area" then
          areaType = 2.
         else
          areaType = 3.

        if areaType < 3 then
          put unformatted substitute( '&1 &2',
            entry( areaType, areaTypeCode ),
            _areaExtent._Extent-path
           ).
         else
          put unformatted substitute( '&1 "&2":&3,&4;&5 &6',
            entry( areaType, areaTypeCode ),
            _Area._area-name,
            _Area._area-number,
            exp( 2, _Area._area-recbits ),
            _Area._area-clustersize,
            _areaExtent._Extent-path
           ).

        blksVar = max( extBlks, ( _AreaStatus-totblocks - blksAlloc )).

        /* _areaExtent._extent-type values, almost, but not exactly a bitmap
         * 
         *  1 = Control area extent (.db)
         *  4 = Variable length AI extents (.a)
         *  5 = Variable length Data/Schema extents (.d)
         *  6 = Variable length BI extents (.b)
         * 36 = Fixed length AI extents (32 + 4)
         * 37 = Fixed length data/schema extents (32 + 5)
         * 38 = Fixed length BI extents (32 + 6)
         * 39 - Fixed length TL file (32 + 7)
         * 
         */

        if _extent-type >= 36 and _extent-type <= 39 then
          put unformatted " f " _areaExtent._extent-size.

        if _extent-type >= 5 and _extent-type <= 6 and blksVar > 0 then
          put unformatted "		# " blksVar.

        put unformatted skip.

      end.

    end.

    put unformatted "#" skip.
    put unformatted skip.

    output close.

    qh:query-close.

    delete object bh.
    delete object qh.

    run lib/fileviewer.p ( rptOut ).

  end.

return.

