/* restlib.p
 *
 * simple program for making ProTop's internal REST calls available:
 *
 *	post2portal( data, host, port, path, options, proxy, extraHeaders )
 *	getURL( host, port, path, credentials, options, proxy, xtraHeaders, fileName, output result, output xrspHdr )
 *
 * i.e.
 *
 * run util/restlib.p persistent.
 *
 * run getURL(
 *   'demo.wss.com',
 *   '80',
 *   '/pt3upd/pt3.1415x-src.tar.gz',
 *   '',		/* optional username:password	*/
 *   '',		/* optional options like -ssl	*/
 *   '',		/* optional proxy		*/
 *   '',		/* optional extra headers	*/
 *   'pt3.tar.gz',
 *   xResult,
 *   xrspHdr
 * ).
 *
 * run post2portal(
 *   'siteName=z9927&dbIdList=all&description=xpostTest&duration=1&oper=add&req=maintenance', 
 *   'demo.wss.com', 
 *   '80',
 *   '/api/outage.php', 
 *   portalOptions,
 *   portalProxy,
 *   'Content-Type: application/x-www-form-urlencoded'
 * ).
 *
 */

define new global shared variable dbgMode     as integer   no-undo.
define new global shared variable portalProxy as character no-undo.

run ssg/sausage02.p persistent.

{ssg/sausage27.i}

portalProxy = os-getenv( "PROXY" ).					/* proxy server, if defined			*/
if portalProxy = ? then portalProxy = "".

dbgMode = 5.								/* 7 is about as high as you really want to go	*/

session:add-super-procedure( this-procedure ).

return.
